unit Utils;
////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////

                                interface
////////////////////////////////////////////////////////////////////////////////

procedure AddCRC8(var ACRC: byte; AByte: byte);
function HexStrToASCIIStr(AStr: string): string;
function HexStrToBinStr(AStr: ansistring): ansistring;
function BinStrToHexStr(AStr: ansistring): ansistring;
function ByteToBinStr(AByte: byte): ansistring;
function BinStrToByte(AStr: ansistring): byte;

                              implementation
////////////////////////////////////////////////////////////////////////////////
uses
  SysUtils;

////////////////////////////////////////////////////////////////////////////////
procedure AddCRC8(var ACRC: byte; AByte: byte);
//  8- CRC
var
  I: integer;
  C: byte;
begin
  for I := 1 to 8 do
  begin
    C := (AByte xor ACRC) and $01;
    AByte := AByte shr 1;
    if C <> 0 then
      ACRC := ACRC xor $18;
    ACRC := (ACRC shr 1) or (C shl 7);
  end;
end;

////////////////////////////////////////////////////////////////////////////////
function HexStrToASCIIStr(AStr: string): string;
var
  k: integer;
  Ts: string;
  Ch: char;
begin
  Result := '';
  if AStr <> '' then
  begin
    AStr := TrimRight(AStr) + ' ';
    repeat
      k := Pos(' ', AStr);
      if k > 0 then
      begin
        Ts := Copy(AStr, 1, k-1);
        Delete(AStr, 1, k);
        Ch := chr(StrToInt('$0' + Ts));
        if Ch > ' ' then
          Result := Result + Ch
        else
          Result := Result + ' ';
      end;
    until k = 0;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
function HexStrToBinStr(AStr: ansistring): ansistring;
var
  k: integer;
begin
  Result:='';
  if AStr <> '' then
  begin
    AStr := TrimRight(AStr) + ' ';
    repeat
      k := Pos(' ', AStr);
      if k > 0 then
      begin
        Result:=Result + ansichar(StrToInt('$0' + Copy(AStr, 1, k-1)));
        Delete(AStr, 1, k);
      end;
    until k = 0;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
function BinStrToHexStr(AStr: ansistring): ansistring;
var
  k: integer;
begin
  Result:='';
  if AStr <> '' then
  begin
    for k := 1 to Length(AStr) do begin
      Result := Result + IntToHex(ord(AStr[k]), 2) + ' ';
    end;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
function ByteToBinStr(AByte: byte): ansistring;
var
  I: integer;
  Mask: byte;
  S: ansistring;
begin
  Mask := $01;
  S := '';
  for I := 1 to 8 do begin
    if (AByte and Mask) = 0 then
      S := '0' + S
    else
      S := '1' + S;
    Mask := Mask shl 1;
    end;
  ByteToBinStr := S;
end;

////////////////////////////////////////////////////////////////////////////////
function BinStrToByte(AStr: ansistring): byte;
var
  I: integer;
  N: byte;
  Tmp: byte;
begin
  Tmp := 0;
  N := 1;
  for I := length(AStr) downto 1 do begin
    if (AStr[I] = '1') then
      Tmp := Tmp + N;
    N := N shl 1;
  end;
  Result := Tmp;
end;

end.

